const DOC_STORE = "document-store";
const BY_SEQ_STORE = "by-sequence";
const LOCAL_STORE = "local-store";
const META_STORE = "metadata-store";
const ATTACH_AND_SEQ_STORE = "attach-seq-store";
const DETECT_BLOB_SUPPORT_STORE = 'detect-blob-support';

onconnect = function(e) {
  e.ports[0].onmessage = function() {

  var req = indexedDB.open("foobar2", 1);

  req.onupgradeneeded = function (e) {
    var db = e.target.result;
    var docStore = db.createObjectStore(DOC_STORE, {keyPath : 'id'});
    db.createObjectStore(BY_SEQ_STORE, {autoIncrement: true})
      .createIndex('_doc_id_rev', '_doc_id_rev', {unique: true});
    db.createObjectStore(META_STORE, {keyPath: 'id', autoIncrement: false});
    db.createObjectStore(DETECT_BLOB_SUPPORT_STORE);

    // added in v2
    docStore.createIndex('deletedOrLocal', 'deletedOrLocal', {unique : false});

    // added in v3
    db.createObjectStore(LOCAL_STORE, {keyPath: '_id'});

    // added in v4
    var attAndSeqStore = db.createObjectStore(ATTACH_AND_SEQ_STORE,
      {autoIncrement: true});
    attAndSeqStore.createIndex('seq', 'seq');
    attAndSeqStore.createIndex('digestSeq', 'digestSeq', {unique: true});
  };

  req.onsuccess = function (e) {
    var idb = e.target.result;
    var txn = idb.transaction([META_STORE, DETECT_BLOB_SUPPORT_STORE], 'readwrite');

    var req = txn.objectStore(META_STORE).get(META_STORE);

    req.onsuccess = function (e) {

      Promise.resolve().then(function(val) {
        var txn = idb.transaction([DOC_STORE], 'readonly');
        var index = txn.objectStore(DOC_STORE).index('deletedOrLocal');
        index.count(IDBKeyRange.only("0")).onsuccess = function (e) {};
        txn.oncomplete = function () {
          var stores = [DOC_STORE, BY_SEQ_STORE];
          var txnResult = idb.transaction(stores, 'readonly');
        }
      });
    };
  };

  req.onerror = idbError(callback);

  }
}
